-rw-r--r-- | delta.jscad | 29 |
1 files changed, 29 insertions, 0 deletions
diff --git a/delta.jscad b/delta.jscad index 326d172..35a777c 100644 --- a/delta.jscad +++ b/delta.jscad @@ -101,97 +101,126 @@ var CONFIG = { nut: { h: 2.3, w: 5.5 }, color: { extrusion: [0.8, 0.8, 0.8, 0.8], pcb: [ 0, 0.3, 0.2, 0.8 ], bulk: [ .9, .9, .9, .2 ], parts: [ 0, 0.8, 0, 0.9 ], softparts: [ 0, 0, 0.8, 0.9 ], heatbed: [0.8, 0.8, 0.8, 0.8 ], glass: [0.9, 0.9, 0.9, 0.7 ] } }; var CD = { base: (function(){ var rv = {}; rv.circumscription_r = CONFIG.base.sl/2/Math.cos(Math.PI/6); rv.outer_inscription_r = Math.sqrt(Math.pow(rv.circumscription_r,2)- Math.pow(CONFIG.base.sl/2,2)); rv.mid_inscription_r = rv.outer_inscription_r-CONFIG.extrusion.w/2; rv.inner_inscription_r = rv.outer_inscription_r-CONFIG.extrusion.w; // TODO: properly calculate rv.column_r = rv.circumscription_r - 48.29; return rv; })(), duetholder: (function() { var rv = {}; var s = CONFIG.base.sl; var l = CONFIG.duet.hole_spacing.x; var w = CONFIG.duet.hole_spacing.y; var h = s*Math.cos(Math.PI/6); var h1 = h*(1-l/s); rv.distance = (h1-w)/3; // hole to side return rv; })() }; console.log(CONFIG); console.log(CD); var U = { hypotenuse: function(a,b) { return Math.sqrt(Math.pow(a,2)+Math.pow(b,2)); }, peek: function(x,m) { console.log(x,m); return x; + }, + axes: function U_axes(o) { + if(!o) o = {}; + var l = o.l||20, g = o.g||0.7; + return union([ + CSG.roundedCylinder({start:[0,0,0],end:[l,0,0]}).setColor([1,0,0,g]), + CSG.roundedCylinder({start:[0,0,0],end:[0,l,0]}).setColor([0,1,0,g]), + CSG.roundedCylinder({start:[0,0,0],end:[0,0,l]}).setColor([0,0,1,g]) + ]); + }, + pextract: function U_pextract(a,pn) { // TODO: monkeypatch Array + return a.map(function(x){return x[pn]}); + }, + hole: function U_hole(o) { + var r = o.r||o.radius||(o.d/2)||(o.diameter/2); + var n = Math.max(Math.round(4*r),4); + return CSG.cylinder({ + start: o.start, end: o.end, + radius: r/Math.cos(Math.PI/n), + resultion: n + }); + }, + + upright: function U_upright() { return new CSG.Connector([0,0,0],[0,0,1],[1,0,0]) }, + downright: function U_downright() { return new CSG.Connector([0,0,0],[0,0,-1],[1,0,0]) }, + P: function U_P(x) { + if(!x.properties.P) return x; + return x.connectTo(x.properties.P,U.upright(),false,0); } + }; /* {h:,w:} */ function nut(o) { var rv = CSG.cylinder({ start:[0,0,0],end:[0,0,o.h], radius: o.w/2/Math.cos(Math.PI/6), resolution: 6 }); rv.properties.axis_connector = new CSG.Connector([0,0,0],[0,0,1],[0,1,0]); return rv; } var E3DV6 = { dimensions: { big_d: 22.3, }, heatsink: function() { var fn = 16; var z=0; var unite = [ {d:16,h:3.7},{d:12,h:6},{d:16,h:3} ].map(function(x) { return CSG.cylinder({ start: [0,0,z], end: [0,0,z-=x.h], radius: x.d/2, resolution: fn }); }); unite.push(CSG.cylinder({ start:[0,0,z-=1.5], end:[0,0,z-=1], radius: 16/2, resolution: fn })); for(var i=0;i<11;++i) unite.push(CSG.cylinder({ start:[0,0,z-=1.5], end:[0,0,z-=1], radius: this.dimensions.big_d/2, resolution: fn })); unite.push(CSG.cylinder({ start:[0,0,z], end: [0,0,-12.7], radiusStart: 10/2, radiusEnd: 8.5/2, /* pretty arbitrary */ resolution: fn })); var rv = union(unite); rv = rv.subtract([CSG.cylinder({ start:[0,0,1], end: [0,0,z-1], radius: 4.2/2, resolution: fn }),CSG.cylinder({ start:[0,0,1], end: [0,0,-6.7/*somewhat arbitrary*/], radius: 8/2, resolution: fn }),CSG.cylinder({ |